unit U_USBout8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, JvHidControllerClass, Menus, ActnList, ComCtrls, RyTimer, inifiles;

var  TimeOut: array [0..7] of integer;
     TimeArc: array [0..7] of integer = (0, 0, 0, 0, 0, 0, 0, 0);
type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    DevListBox: TListBox;
    GroupBoxOut1: TGroupBox;
    GroupBoxOut2: TGroupBox;
    GroupBoxOut3: TGroupBox;
    GroupBoxOut4: TGroupBox;
    GroupBoxOut5: TGroupBox;
    GroupBoxOut6: TGroupBox;
    GroupBoxOut7: TGroupBox;
    GroupBoxOut8: TGroupBox;
    HidCtl: TJvHidDeviceController;
    ActionList1: TActionList;
    ASaveINI: TAction;
    ASetupTime: TAction;
    AReadPort: TAction;
    AResetPort: TAction;
    AProgramm: TAction;
    MainMenu1: TMainMenu;
    NFile: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    About: TMenuItem;
    StatusBar1: TStatusBar;
    P1CheckBox: TCheckBox;
    Action1: TAction;
    LabelOut1: TLabel;
    LabelOut2: TLabel;
    P1Label: TLabel;
    P1Label2: TLabel;
    P2CheckBox: TCheckBox;
    P3CheckBox: TCheckBox;
    P4CheckBox: TCheckBox;
    P5CheckBox: TCheckBox;
    P6CheckBox: TCheckBox;
    P7CheckBox: TCheckBox;
    P8CheckBox: TCheckBox;
    P2Label: TLabel;
    P3Label: TLabel;
    P4Label: TLabel;
    P5Label: TLabel;
    P6Label: TLabel;
    P7Label: TLabel;
    P8Label: TLabel;
    P2Label2: TLabel;
    P3Label2: TLabel;
    P4Label2: TLabel;
    P5Label2: TLabel;
    P6Label2: TLabel;
    P7Label2: TLabel;
    P8Label2: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    Timer3: TTimer;
    Timer4: TTimer;
    Timer5: TTimer;
    Timer6: TTimer;
    Timer7: TTimer;
    Timer8: TTimer;
    PortBtn1: TButton;
    PortBtn2: TButton;
    PortBtn3: TButton;
    PortBtn4: TButton;
    PortBtn5: TButton;
    PortBtn6: TButton;
    PortBtn7: TButton;
    PortBtn8: TButton;
    procedure HidCtlDeviceDataError(HidDev: TJvHidDevice;
      Error: Cardinal);
    procedure HidCtlDeviceChange(Sender: TObject);
    function HidCtlEnumerate(HidDev: TJvHidDevice;
      const Idx: Integer): Boolean;
    function ReportWrite(Rep, N, N1: Byte): Boolean;
    procedure PortBtn1Click(Sender: TObject);
    procedure PortBtn2Click(Sender: TObject);
    procedure PortBtn3Click(Sender: TObject);
    procedure PortBtn4Click(Sender: TObject);
    procedure PortBtn5Click(Sender: TObject);
    procedure PortBtn6Click(Sender: TObject);
    procedure PortBtn7Click(Sender: TObject);
    procedure PortBtn8Click(Sender: TObject);
    procedure AReadPortExecute(Sender: TObject);
    procedure AResetPortExecute(Sender: TObject);
    procedure GroupBoxOut1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut5MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut6MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut7MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBoxOut8MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GroupBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ASetupTimeExecute(Sender: TObject);
    procedure P1CheckBoxClick(Sender: TObject);
    procedure P2CheckBoxClick(Sender: TObject);
    procedure P3CheckBoxClick(Sender: TObject);
    procedure P4CheckBoxClick(Sender: TObject);
    procedure P5CheckBoxClick(Sender: TObject);
    procedure P6CheckBoxClick(Sender: TObject);
    procedure P7CheckBoxClick(Sender: TObject);
    procedure P8CheckBoxClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure Timer5Timer(Sender: TObject);
    procedure Timer6Timer(Sender: TObject);
    procedure Timer7Timer(Sender: TObject);
    procedure Timer8Timer(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure SaveIni;
    procedure ReadIni;
  public
    { Public declarations }
    CurrentDevice: TJvHidDevice;
  published
    procedure ShowRead(HidDev: TJvHidDevice; ReportID: Byte;
      const Data: Pointer; Size: Word);
end;

var
  Form1: TForm1;

implementation

uses U_Time, U_About;

{$R *.dfm}

const LOn: string = '.';
      LOff: string = '.';

var NRead: cardinal;
    IniFile: TIniFile;

procedure TForm1.HidCtlDeviceDataError(
  HidDev: TJvHidDevice; Error: Cardinal);
begin
  ShowMessage('READ ERROR: ' + SysErrorMessage(Error));
end;

//  HID 
procedure TForm1.HidCtlDeviceChange(Sender: TObject);
var
  Dev: TJvHidDevice;
  I: Integer;
begin
  if Assigned(DevListBox) then
  begin
    for I := 0 to DevListBox.Items.Count -1  do
    begin
      Dev := TJvHidDevice(DevListBox.Items.Objects[I]);
      Dev.Free;
    end;
    DevListBox.Clear;
    HidCtl.Enumerate;
    //     
    if DevListBox.Items.Count > 0 then
    begin
      DevListBox.ItemIndex:= DevListBox.Items.IndexOf('Device VID=0838 PID=0438');
        if DevListBox.ItemIndex < 0 then
            DevListBox.ItemIndex:= DevListBox.Items.IndexOf('USBout8');
        if DevListBox.ItemIndex < 0 then
          ShowMessage('   ');
    end;
  end;

end;

//  
function TForm1.HidCtlEnumerate(HidDev: TJvHidDevice;
  const Idx: Integer): Boolean;
var
  N: Integer;
  Dev: TJvHidDevice;
begin
  if Assigned(DevListBox) then
  begin
    //     
    if HidDev.ProductName <> '' then
      N := DevListBox.Items.Add(HidDev.ProductName)
    else
     //  Pid  Vid
      N := DevListBox.Items.Add(Format('Device VID=%.4x PID=%.4x',
           [HidDev.Attributes.VendorID, HidDev.Attributes.ProductID]));
    HidCtl.CheckOutByIndex(Dev, Idx);
    DevListBox.Items.Objects[N] := Dev;
  end;
  Result := True;
end;

//  
function TForm1.ReportWrite(Rep, N, N1: Byte): Boolean;
var
  Buf: array [0..64] of Byte;
  Written: Cardinal;
  ToWrite: Cardinal;
  Str: string;
  I: Integer;
  Res: Boolean ;
begin
    Res := False;
    CurrentDevice := nil;
  if (DevListBox.Items.Count > 0) and (DevListBox.ItemIndex >= 0) then
  begin
    CurrentDevice := TJvHidDevice(DevListBox.Items.Objects[DevListBox.ItemIndex]);
  end;
  if Assigned(CurrentDevice) then
  begin
    Buf[0] := Rep;
    ToWrite := CurrentDevice.Caps.OutputReportByteLength;
    Buf[1] := N;
    Buf[2] := N1;
    Res:= CurrentDevice.WriteFile(Buf, ToWrite, Written);
    Str := Format('W %.2x  ', [Buf[0]]);
    for I := 1 to Written-1 do
      Str := Str + Format('%.2x ', [Buf[I]]);
  end;
  Result := Res;
end;

procedure TForm1.ShowRead(HidDev: TJvHidDevice; ReportID: Byte;
  const Data: Pointer; Size: Word);
var
  I: Integer;
  Str: string;
begin
  for I := 0 to Size - 1 do
    Str := Format('%.2d', [Cardinal(PChar(Data)[I])]);
  NRead := StrToInt(Str);
end;

procedure TForm1.AReadPortExecute(Sender: TObject);
const P1 = 1;
      P2 = 2;
      P3 = 4;
      P4 = 8;
      P5 = 16;
      P6 = 32;
      P7 = 64;
      P8 = 128;
begin
    if (DevListBox.Items.Count > 0) and (DevListBox.ItemIndex >= 0) then
  begin
    CurrentDevice := TJvHidDevice(DevListBox.Items.Objects[DevListBox.ItemIndex]);
    if not CurrentDevice.HasReadWriteAccess then exit;
  end;
  if NRead and P1 > 0  then begin
    PortBtn1.Caption := LOn;
    end;
  if NRead and P2 > 0  then begin
    PortBtn2.Caption := LOn;
    end;
  if NRead and P3 > 0  then begin
    PortBtn3.Caption := LOn;
    end;
  if NRead and P4 > 0  then begin
    PortBtn4.Caption := LOn;
    end;
  if NRead and P5 > 0  then begin
    PortBtn5.Caption := LOn;
    end;
  if NRead and P6 > 0  then begin
    PortBtn6.Caption := LOn;
    end;
  if NRead and P7 > 0  then begin
    PortBtn7.Caption := LOn;
    end;
  if NRead and P8 > 0  then begin
    PortBtn8.Caption := LOn;
    end;
end;

procedure TForm1.AResetPortExecute(Sender: TObject);
begin
  ReportWrite(4, 77, 0);

  PortBtn1.Caption := LOff;

  PortBtn2.Caption := LOff;

  PortBtn3.Caption := LOff;

  PortBtn4.Caption := LOff;

  PortBtn5.Caption := LOff;

  PortBtn6.Caption := LOff;

  PortBtn7.Caption := LOff;

  PortBtn8.Caption := LOff;
end;

procedure TForm1.GroupBoxOut1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 1';
end;

procedure TForm1.GroupBoxOut2MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 2';
end;

procedure TForm1.GroupBoxOut3MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 3';
end;

procedure TForm1.GroupBoxOut4MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 4';
end;

procedure TForm1.GroupBoxOut5MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 5';
end;

procedure TForm1.GroupBoxOut6MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 6';
end;

procedure TForm1.GroupBoxOut7MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 7';
end;

procedure TForm1.GroupBoxOut8MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := ' 8';
end;

procedure TForm1.StatusBar1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.GroupBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.ASetupTimeExecute(Sender: TObject);
var F: TPTime;
begin
  Application.CreateForm(TPTime, F);
  F.ShowModal;
  F.Free;
end;

procedure TForm1.PortBtn1Click(Sender: TObject);
begin
  if PortBtn1.Caption = LOff
    then begin
      ReportWrite(2, 1, 0);
      PortBtn1.Caption := LOn;
      if P1CheckBox.Checked then
        begin
          TimeOut[0] := TimeArc[0];
          Timer1.Enabled := true;
          PortBtn1.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 1, 0);
      PortBtn1.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn2Click(Sender: TObject);
begin
  if PortBtn2.Caption = LOff
    then begin
      ReportWrite(2, 2, 0);
      PortBtn2.Caption := LOn;
      if P2CheckBox.Checked then
        begin
          TimeOut[1] := TimeArc[1];
          Timer2.Enabled := true;
          PortBtn2.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 2, 0);
      PortBtn2.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn3Click(Sender: TObject);
begin
  if PortBtn3.Caption = LOff
    then begin
      ReportWrite(2, 4, 0);
      PortBtn3.Caption := LOn;
      if P3CheckBox.Checked then
        begin
          TimeOut[2] := TimeArc[2];
          Timer3.Enabled := true;
          PortBtn3.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 4, 0);
      PortBtn3.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn4Click(Sender: TObject);
begin
  if PortBtn4.Caption = LOff
    then begin
      ReportWrite(2, 8, 0);
      PortBtn4.Caption := LOn;
      if P4CheckBox.Checked then
        begin
          TimeOut[3] := TimeArc[3];
          Timer4.Enabled := true;
          PortBtn4.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 8, 0);
      PortBtn4.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn5Click(Sender: TObject);
begin
  if PortBtn5.Caption = LOff
    then begin
      ReportWrite(2, 16, 0);
      PortBtn5.Caption := LOn;
      if P5CheckBox.Checked then
        begin
          TimeOut[4] := TimeArc[4];
          Timer5.Enabled := true;
          PortBtn5.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 16, 0);
      PortBtn5.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn6Click(Sender: TObject);
begin
  if PortBtn6.Caption = LOff
    then begin
      ReportWrite(2, 32, 0);
      PortBtn6.Caption := LOn;
      if P6CheckBox.Checked then
        begin
          TimeOut[5] := TimeArc[5];
          Timer6.Enabled := true;
          PortBtn6.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 32, 0);
      PortBtn6.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn7Click(Sender: TObject);
begin
  if PortBtn7.Caption = LOff
    then begin
      ReportWrite(2, 64, 0);
      PortBtn7.Caption := LOn;
      if P7CheckBox.Checked then
        begin
          TimeOut[6] := TimeArc[6];
          Timer7.Enabled := true;
          PortBtn7.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 64, 0);
      PortBtn7.Caption := LOff;
      end;
end;

procedure TForm1.PortBtn8Click(Sender: TObject);
begin
  if PortBtn8.Caption = LOff
    then begin
      ReportWrite(2, 128, 0);
      PortBtn8.Caption := LOn;
      if P8CheckBox.Checked then
        begin
          TimeOut[7] := TimeArc[7];
          Timer8.Enabled := true;
          PortBtn8.Enabled := false;
        end;
      end
    else begin
      ReportWrite(3, 128, 0);
      PortBtn8.Caption := LOff;
      end;
end;

procedure TForm1.P1CheckBoxClick(Sender: TObject);
begin
  if P1CheckBox.Checked
    then P1CheckBox.Caption := LOn
    else P1CheckBox.Caption := LOff;
end;

procedure TForm1.P2CheckBoxClick(Sender: TObject);
begin
  if P2CheckBox.Checked
    then P2CheckBox.Caption := LOn
    else P2CheckBox.Caption := LOff;
end;

procedure TForm1.P3CheckBoxClick(Sender: TObject);
begin
  if P3CheckBox.Checked
    then P3CheckBox.Caption := LOn
    else P3CheckBox.Caption := LOff;
end;

procedure TForm1.P4CheckBoxClick(Sender: TObject);
begin
  if P4CheckBox.Checked
    then P4CheckBox.Caption := LOn
    else P4CheckBox.Caption := LOff;
end;

procedure TForm1.P5CheckBoxClick(Sender: TObject);
begin
  if P5CheckBox.Checked
    then P5CheckBox.Caption := LOn
    else P5CheckBox.Caption := LOff;
end;

procedure TForm1.P6CheckBoxClick(Sender: TObject);
begin
  if P6CheckBox.Checked
    then P6CheckBox.Caption := LOn
    else P6CheckBox.Caption := LOff;
end;

procedure TForm1.P7CheckBoxClick(Sender: TObject);
begin
  if P7CheckBox.Checked
    then P7CheckBox.Caption := LOn
    else P7CheckBox.Caption := LOff;
end;

procedure TForm1.P8CheckBoxClick(Sender: TObject);
begin
  if P8CheckBox.Checked
    then P8CheckBox.Caption := LOn
    else P8CheckBox.Caption := LOff;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  P1Label2.Caption := IntToStr(TimeOut[0]);
  if TimeOut[0] < 1
    then begin
        Timer1.Enabled := false;
        ReportWrite(3, 1, 0);
        PortBtn1.Caption := LOff;
        PortBtn1.Enabled := true;
        P1Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[0]);
      end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  P2Label2.Caption := IntToStr(TimeOut[1]);
  if TimeOut[1] < 1
    then begin
        Timer2.Enabled := false;
        ReportWrite(3, 2, 0);
        PortBtn2.Caption := LOff;
        PortBtn2.Enabled := true;
        P2Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[1]);
      end;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  P3Label2.Caption := IntToStr(TimeOut[2]);
  if TimeOut[2] < 1
    then begin
        Timer3.Enabled := false;
        ReportWrite(3, 4, 0);
        PortBtn3.Caption := LOff;
        PortBtn3.Enabled := true;
        P3Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[2]);
      end;
end;

procedure TForm1.Timer4Timer(Sender: TObject);
begin
  P4Label2.Caption := IntToStr(TimeOut[3]);
  if TimeOut[3] < 1
    then begin
        Timer4.Enabled := false;
        ReportWrite(3, 8, 0);
        PortBtn4.Caption := LOff;
        PortBtn4.Enabled := true;
        P4Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[3]);
      end;
end;

procedure TForm1.Timer5Timer(Sender: TObject);
begin
  P5Label2.Caption := IntToStr(TimeOut[4]);
  if TimeOut[4] < 1
    then begin
        Timer5.Enabled := false;
        ReportWrite(3, 16, 0);
        PortBtn5.Caption := LOff;
        PortBtn5.Enabled := true;
        P5Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[4]);
      end;
end;

procedure TForm1.Timer6Timer(Sender: TObject);
begin
  P6Label2.Caption := IntToStr(TimeOut[5]);
  if TimeOut[5] < 1
    then begin
        Timer6.Enabled := false;
        ReportWrite(3, 32, 0);
        PortBtn6.Caption := LOff;
        PortBtn6.Enabled := true;
        P6Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[5]);
      end;
end;

procedure TForm1.Timer7Timer(Sender: TObject);
begin
  P7Label2.Caption := IntToStr(TimeOut[6]);
  if TimeOut[6] < 1
    then begin
        Timer7.Enabled := false;
        ReportWrite(3, 64, 0);
        PortBtn7.Caption := LOff;
        PortBtn7.Enabled := true;
        P7Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[6]);
      end;
end;

procedure TForm1.Timer8Timer(Sender: TObject);
begin
  P8Label2.Caption := IntToStr(TimeOut[7]);
  if TimeOut[7] < 1
    then begin
        Timer8.Enabled := false;
        ReportWrite(3, 128, 0);
        PortBtn8.Caption := LOff;
        PortBtn8.Enabled := true;
        P8Label2.Caption := '';
      end
    else begin
        Dec(TimeOut[7]);
      end;
end;

procedure TForm1.SaveIni;
var
  IniPath: string;
  FileName: string;
begin
  GetDir(0,IniPath);
  FileName:=IniPath+'\Out8.ini';
  IniFile:=TIniFile.Create(FileName);
  IniFile.WriteInteger('Port1','Time',TimeArc[0]);
  IniFile.WriteInteger('Port2','Time',TimeArc[1]);
  IniFile.WriteInteger('Port3','Time',TimeArc[2]);
  IniFile.WriteInteger('Port4','Time',TimeArc[3]);
  IniFile.WriteInteger('Port5','Time',TimeArc[4]);
  IniFile.WriteInteger('Port6','Time',TimeArc[5]);
  IniFile.WriteInteger('Port7','Time',TimeArc[6]);
  IniFile.WriteInteger('Port8','Time',TimeArc[7]);
  IniFile.WriteBool('Port1','Check',P1CheckBox.Checked);
  IniFile.WriteBool('Port2','Check',P2CheckBox.Checked);
  IniFile.WriteBool('Port3','Check',P3CheckBox.Checked);
  IniFile.WriteBool('Port4','Check',P4CheckBox.Checked);
  IniFile.WriteBool('Port5','Check',P5CheckBox.Checked);
  IniFile.WriteBool('Port6','Check',P6CheckBox.Checked);
  IniFile.WriteBool('Port7','Check',P7CheckBox.Checked);
  IniFile.WriteBool('Port8','Check',P8CheckBox.Checked);
  IniFile.Free;
end;

procedure TForm1.ReadIni;
var
  IniPath: string;
  FileName: string;
begin
  GetDir(0,IniPath);
  FileName:=IniPath+'\Out8.ini';
  IniFile:=TIniFile.Create(FileName);
  TimeArc[0]:=IniFile.ReadInteger('Port1','Time',TimeArc[0]);
  TimeArc[1]:=IniFile.ReadInteger('Port2','Time',TimeArc[1]);
  TimeArc[2]:=IniFile.ReadInteger('Port3','Time',TimeArc[2]);
  TimeArc[3]:=IniFile.ReadInteger('Port4','Time',TimeArc[3]);
  TimeArc[4]:=IniFile.ReadInteger('Port5','Time',TimeArc[4]);
  TimeArc[5]:=IniFile.ReadInteger('Port6','Time',TimeArc[5]);
  TimeArc[6]:=IniFile.ReadInteger('Port7','Time',TimeArc[6]);
  TimeArc[7]:=IniFile.ReadInteger('Port8','Time',TimeArc[7]);
  P1CheckBox.Checked:=IniFile.ReadBool('Port1','Check',P1CheckBox.Checked);
  P2CheckBox.Checked:=IniFile.ReadBool('Port2','Check',P2CheckBox.Checked);
  P3CheckBox.Checked:=IniFile.ReadBool('Port3','Check',P3CheckBox.Checked);
  P4CheckBox.Checked:=IniFile.ReadBool('Port4','Check',P4CheckBox.Checked);
  P5CheckBox.Checked:=IniFile.ReadBool('Port5','Check',P5CheckBox.Checked);
  P6CheckBox.Checked:=IniFile.ReadBool('Port6','Check',P6CheckBox.Checked);
  P7CheckBox.Checked:=IniFile.ReadBool('Port7','Check',P7CheckBox.Checked);
  P8CheckBox.Checked:=IniFile.ReadBool('Port8','Check',P8CheckBox.Checked);
  IniFile.Free;
end;


procedure TForm1.N1Click(Sender: TObject);
begin
  SaveIni;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ReadIni;
end;

procedure TForm1.AboutClick(Sender: TObject);
var F: TAbout;
begin
  Application.CreateForm(TAbout, F);
  F.ShowModal;
  F.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveIni;
end;

end.
